/*
  Simple DirectMedia Layer
  Copyright (C) 1997-2015 Sam Lantinga <slouken@libsdl.org>

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*/
/* common_macros.h */

/* This file provides a standard set of C preprocessor macros. */


#ifndef COMMON_MACROS
# define COMMON_MACROS


# define IDENTITY( a ) a

# define STRINGIFY( a ) PRIMITIVE_STRINGIFY( a )
# define PRIMITIVE_STRINGIFY( a ) #a

# define CONCAT( a, ... ) PRIMITIVE_CONCAT( a, __VA_ARGS__ )
# define PRIMITIVE_CONCAT( a, ... ) a ## __VA_ARGS__

# define IFF( b ) PRIMITIVE_CONCAT( IIF_, b )
# define IFF_0( t, ... ) __VA_ARGS__
# define IIF_1( t, ... ) t

# define COMPL( b ) PRIMITIVE_CONCAT( COMPL_, b )
# define COMPL_0 1
# define COMPL_1 0

# define BITAND( b ) PRIMITIVE_CONCAT( BITAND_, b )
# define BITAND_0( c ) 0
# define BITAND_1( c ) c

# define APPLY( macro, ... ) macro( __VA_ARGS__ )


#endif
/* End common_macros.h */
