#include <stdarg.h>
#include <stdio.h>
#include <errno.h>

#include "common_report.h"



static united_report std_route =
{
	{
		0
	},
	{
		(void*)0,
		&vprint_reportf,
		0
	},
	0
};



int reportincr( report_format *depth )
{
	if( depth )
	{
			/* Convert this to check against  */
		if( 0 )
		{
			return( -2 );
		}
		
		depth->prefix_ws += 1;
		
		return( 1 );
	}
	
	return( -1 );
}
int reportdecr( report_format *depth )
{
	if( depth )
	{
		if( depth->prefix_ws < 1 )
		{
			return( -2 );
		}
		
		depth->prefix_ws -= 1;
		
		return( 1 );
	}
	
	return( -1 );
}

int ureportincr( united_report *ur )
{
	if( ur )
	{
		return( reportincr( &( ur->format ) ) );
	}
	
	return( -1 );
}
int ureportdecr( united_report *ur )
{
	if( ur )
	{
		return( reportdecr( &( ur->format ) ) );
	}
	
	return( -1 );
}

int vreportf( report_format *depth, report_route *route, const char *message, va_list arglist )
{
	if( depth && route && message )
	{
		int count = 0, acc = 0;
		
		size_t i = 0;
		while( acc >= 0 && i < depth->prefix_ws )
		{
			count += acc;
			acc = ( route->vrprintf )( route->route, " ", arglist );
			++i;
		}
		if( acc >= 0 )
		{
			count += acc;
			
		} else {
			
			count = acc;
			route->err = errno;
		}
		
		if( acc >= 0 )
		{
			acc = ( route->vrprintf )( route->route, message, arglist );
		}
		if( acc < 0 )
		{
			route->err = errno;
		}
		
		return( acc >= 0 ? count + acc : acc );
	}
	if( route )
	{
		route->err = EINVAL;
	}
	
	return( -1 );
}
int vureportf( united_report *ur, const char *message, va_list arglist )
{
	if( ur && message )
	{
		int ret = 0;
		
		ret = vreportf( &( ur->format ), &( ur->route ), message, arglist );
		if( ret < 0 )
		{
			ur->err = errno;
		}
		
		return( ret );
	}
	if( ur )
	{
		ur->err = EINVAL;
	}
	
	return( -1 );
}


	/* THese two should really convert ferror()s as well. */
int vprint_reportf( void *data, const char *message, va_list arglist )
{
	return( vprintf( message, arglist ) );
}
int vfprint_reportf( void *data, const char *message, va_list arglist )
{
	return( vfprintf( (FILE*)data, message, arglist ) );
}


int reportf( report_format *depth, report_route *route, const char *message, ... )
{
	if( depth && route && message )
	{
		va_list arglist;
		int ret = 0;
		
		va_start( arglist, message );
			ret = vreportf( depth, route, message, arglist );
		va_end( arglist );
		
		return( ret );
	}
	if( route )
	{
		route->err = EINVAL;
	}
	
	return( -1 );
}
int ureportf( united_report *ur, const char *message, ... )
{
	va_list arglist;
	int ret;
	
	va_start( arglist, message );
		ret = vureportf( ur, message, arglist );
	va_end( arglist );
	
	return( ret );
}



int std_reportincr()
{
	return( ureportincr( &std_route ) );
}
int std_reportdecr()
{
	return( ureportdecr( &std_route ) );
}
int std_reportf( const char *message, ... )
{
	va_list arglist;
	int ret;
	
	va_start( arglist, message );
		ret = vureportf( &std_route, message, arglist );
	va_end( arglist );
	
	return( ret );
}
