
#ifndef STD_COMMONRPT_H
# define STD_COMMONRPT_H 0


# include <errno.h>



	/* Invalid arguments. */
# ifndef EINVAL
#  define EINVAL -1
# endif



#ifndef NDEBUG

# define DEBUG_PRINTF( ... ) std_reportf( __VA_ARGS__ )
# define DEBUG_PRINTTRI( ... ) DEBUG_PRINT_TRI( __VA_ARGS__ )

# define DEBUG_OUTPINCR std_reportincr()
# define DEBUG_OUTPDECR std_reportdecr()

#else

# define DEBUG_PRINTF( ... )
# define DEBUG_PRINTTRI( ... )

# define DEBUG_OUTPINCR 1
# define DEBUG_OUTPDECR 1

#endif



typedef struct report_format
{
	size_t prefix_ws;
	
} report_format;

typedef struct report_route
{
		/* Should behave like vfprintf. */
	void *route;
	int (*vrprintf)( void*, const char*, va_list );
		/* 0 if no error. Else non-zero. */
	int err;
	
} report_route;

typedef struct united_report
{
	report_format format;
	report_route route;
		/* 0 if no error. Else non-zero. */
	int err;
	
} united_report;



int reportincr( report_format *depth );
int reportdecr( report_format *depth );

int ureportincr( united_report *ur );
int ureportdecr( united_report *ur );

int vreportf( report_format *depth, report_route *route, const char *message, va_list arglist );
int vureportf( united_report *ur, const char *message, va_list arglist );


int vprint_reportf( void *data, const char *message, va_list arglist );
int vfprint_reportf( void *data, const char *message, va_list arglist );


int reportf( report_format *depth, report_route *route, const char *message, ... );
int ureportf( united_report *ur, const char *message, ... );



int std_reportincr();
int std_reportdecr();
int std_reportf( const char *message, ... );

#endif
